// 该类用于管理 SQL 笔记的数据操作，可能是在笔记应用中对笔记信息的管理和同步操作
public class SqlNote {
    // 日志标签，使用类的简单名称
    private static final String TAG = SqlNote.class.getSimpleName();
    // 表示无效的 ID
    private static final int INVALID_ID = -99999;
    // 笔记查询的投影，指定了需要查询的笔记列
    public static final String[] PROJECTION_NOTE = new String[] {
            NoteColumns.ID, NoteColumns.ALERTED_DATE, NoteColumns.BG_COLOR_ID,
            NoteColumns.CREATED_DATE, NoteColumns.HAS_ATTACHMENT, NoteColumns.MODIFIED_DATE,
            NoteColumns.NOTES_COUNT, NoteColumns.PARENT_ID, NoteColumns.SNIPPET, NoteColumns.TYPE,
            NoteColumns.WIDGET_ID, NoteColumns.WIDGET_TYPE, NoteColumns.SYNC_ID,
            NoteColumns.LOCAL_MODIFIED, NoteColumns.ORIGIN_PARENT_ID, NoteColumns.GTASK_ID,
            NoteColumns.VERSION
    };
    // 投影中笔记 ID 列的索引
    public static final int ID_COLUMN = 0;
    // 投影中提醒日期列的索引
    public static final int ALERTED_DATE_COLUMN = 1;
    // 投影中背景颜色 ID 列的索引
    public static final int BG_COLOR_ID_COLUMN = 2;
    // 投影中创建日期列的索引
    public static final int CREATED_DATE_COLUMN = 3;
    // 投影中有附件标记列的索引
    public static final int HAS_ATTACHMENT_COLUMN = 4;
    // 投影中修改日期列的索引
    public static final int MODIFIED_DATE_COLUMN = 5;
    // 投影中笔记计数列的索引
    public static final int NOTES_COUNT_COLUMN = 6;
    // 投影中父 ID 列的索引
    public static final int PARENT_ID_COLUMN = 7;
    // 投影中摘要列的索引
    public static final int SNIPPET_COLUMN = 8;
    // 投影中类型列的索引
    public static final int TYPE_COLUMN = 9;
    // 投影中窗口小部件 ID 列的索引
    public static final int WIDGET_ID_COLUMN = 10;
    // 投影中窗口小部件类型列的索引
    public static final int WIDGET_TYPE_COLUMN = 11;
    // 投影中同步 ID 列的索引
    public static final int SYNC_ID_COLUMN = 12;
    // 投影中本地修改标记列的索引
    public static final int LOCAL_MODIFIED_COLUMN = 13;
    // 投影中原父 ID 列的索引
    public static final int ORIGIN_PARENT_ID_COLUMN = 14;
    // 投影中 GTASK ID 列的索引
    public static final int GTASK_ID_COLUMN = 15;
    // 投影中版本列的索引
    public static final int VERSION_COLUMN = 16;


    // 上下文对象，用于获取系统服务等
    private Context mContext;
    // 内容解析器，用于操作内容提供者的数据
    private ContentResolver mContentResolver;
    // 标记是否为创建操作
    private boolean mIsCreate;
    // 笔记的 ID
    private long mId;
    // 笔记的提醒日期
    private long mAlertDate;
    // 笔记的背景颜色 ID
    private int mBgColorId;
    // 笔记的创建日期
    private long mCreatedDate;
    // 笔记是否有附件的标记
    private int mHasAttachment;
    // 笔记的修改日期
    private long mModifiedDate;
    // 笔记的父 ID
    private long mParentId;
    // 笔记的摘要
    private String mSnippet;
    // 笔记的类型
    private int mType;
    // 笔记关联的窗口小部件 ID
    private int mWidgetId;
    // 笔记关联的窗口小部件类型
    private int mWidgetType;
    // 笔记的原父 ID
    private long mOriginParent;
    // 笔记的版本
    private long mVersion;
    // 存储不同的笔记数据值，可能用于更新操作
    private ContentValues mDiffNoteValues;
    // 存储 SqlData 列表，可能用于存储笔记的数据内容
    private ArrayList<SqlData> mDataList;


    // 构造函数，用于创建新的笔记对象，初始化成员变量
    public SqlNote(Context context) {
        mContext = context;
        mContentResolver = context.getContentResolver();
        mIsCreate = true;
        mId = INVALID_ID;
        mAlertDate = 0;
        mBgColorId = ResourceParser.getDefaultBgId(context);
        mCreatedDate = System.currentTimeMillis();
        mHasAttachment = 0;
        mModifiedDate = System.currentTimeMillis();
        mParentId = 0;
        mSnippet = "";
        mType = Notes.TYPE_NOTE;
        mWidgetId = AppWidgetManager.INVALID_APPWIDGET_ID;
        mWidgetType = Notes.TYPE_WIDGET_INVALIDE;
        mOriginParent = 0;
        mVersion = 0;
        mDiffNoteValues = new ContentValues();
        mDataList = new ArrayList<SqlData>();
    }


    // 构造函数，根据 Cursor 初始化笔记对象，用于从数据库中加载笔记信息
    public SqlNote(Context context, Cursor c) {
        mContext = context;
        mContentResolver = context.getContentResolver();
        mIsCreate = false;
        loadFromCursor(c);
        mDataList = new ArrayList<SqlData>();
        if (mType == Notes.TYPE_NOTE)
            loadDataContent();
        mDiffNoteValues = new ContentValues();
    }


    // 构造函数，根据笔记 ID 初始化笔记对象，从数据库中加载笔记信息
    public SqlNote(Context context, long id) {
        mContext = context;
        mContentResolver = context.getContentResolver();
        mIsCreate = false;
        loadFromCursor(id);
        mDataList = new ArrayList<SqlData>();
        if (mType == Notes.TYPE_NOTE)
            loadDataContent();
        mDiffNoteValues = new ContentValues();
    }


    // 从指定的笔记 ID 加载笔记信息
    private void loadFromCursor(long id) {
        Cursor c = null;
        try {
            c = mContentResolver.query(Notes.CONTENT_NOTE_URI, PROJECTION_NOTE, "(_id=?)",
                    new String[] {
                        String.valueOf(id)
                    }, null);
            if (c!= null) {
                c.moveToNext();
                loadFromCursor(c);
            } else {
                Log.w(TAG, "loadFromCursor: cursor = null");
            }
        } finally {
            if (c!= null)
                c.close();
        }
    }


    // 从 Cursor 中加载笔记信息
    private void loadFromCursor(Cursor c) {
        mId = c.getLong(ID_COLUMN);
        mAlertDate = c.getLong(ALERTED_DATE_COLUMN);
        mBgColorId = c.getInt(BG_COLOR_ID_COLUMN);
        mCreatedDate = c.getLong(CREATED_DATE_COLUMN);
        mHasAttachment = c.getInt(HAS_ATTACHMENT_COLUMN);
        mModifiedDate = c.getLong(MODIFIED_DATE_COLUMN);
        mParentId = c.getLong(PARENT_ID_COLUMN);
        mSnippet = c.getString(SNIPPET_COLUMN);
        mType = c.getInt(TYPE_COLUMN);
        mWidgetId = c.getInt(WIDGET_ID_COLUMN);
        mWidgetType = c.getInt(WIDGET_TYPE_COLUMN);
        mVersion = c.getLong(VERSION_COLUMN);
    }


    // 加载笔记的数据内容
    private void loadDataContent() {
        Cursor c = null;
        mDataList.clear();
        try {
            c = mContentResolver.query(Notes.CONTENT_DATA_URI, SqlData.PROJECTION_DATA,
                    "(note_id=?)", new String[] {
                        String.valueOf(mId)
                    }, null);
            if (c!= null) {
                if (c.getCount() == 0) {
                    Log.w(TAG, "it seems that the note has not data");
                    return;
                }
                while (c.moveToNext()) {
                    SqlData data = new SqlData(mContext, c);
                    mDataList.add(data);
                }
            } else {
                Log.w(TAG, "loadDataContent: cursor = null");
            }
        } finally {
            if (c!= null)
                c.close();
        }
    }


    // 根据 JSON 对象设置笔记内容
    public boolean setContent(JSONObject js) {
        try {
            JSONObject note = js.getJSONObject(GTaskStringUtils.META_HEAD_NOTE);
            if (note.getInt(NoteColumns.TYPE) == Notes.TYPE_SYSTEM) {
                Log.w(TAG, "cannot set system folder");
            } else if (note.getInt(NoteColumns.TYPE) == Notes.TYPE_FOLDER) {
                // 对于文件夹，仅更新摘要和类型
                String snippet = note.has(NoteColumns.SNIPPET)? note
                       .getString(NoteColumns.SNIPPET) : "";
                if (mIsCreate ||!mSnippet.equals(snippet)) {
                    mDiffNoteValues.put(NoteColumns.SNIPPET, snippet);
                }
                mSnippet = snippet;


                int type = note.has(NoteColumns.TYPE)? note.getInt(NoteColumns.TYPE)
                        : Notes.TYPE_NOTE;
                if (mIsCreate || mType!= type) {
                    mDiffNoteValues.put(NoteColumns.TYPE, type);
                }
                mType = type;
            } else if (note.getInt(NoteColumns.TYPE) == Notes.TYPE_NOTE) {
                JSONArray dataArray = js.getJSONArray(GTaskStringUtils.META_HEAD_DATA);
                long id = note.has(NoteColumns.ID)? note.getLong(NoteColumns.ID) : INVALID_ID;
                if (mIsCreate || mId!= id) {
                    mDiffNoteValues.put(NoteColumns.ID, id);
                }
                mId = id;


                long alertDate = note.has(NoteColumns.ALERTED_DATE)? note
                       .getLong(NoteColumns.ALERTED_DATE) : 0;
                if (mIsCreate || mAlertDate!= alertDate) {
                    mDiffNoteValues.put(NoteColumns.ALERTED_DATE, alertDate);
                }
                mAlertDate = alertDate;


                int bgColorId = note.has(NoteColumns.BG_COLOR_ID)? note
                       .getInt(NoteColumns.BG_COLOR_ID) : ResourceParser.getDefaultBgId(mContext);
                if (mIsCreate || mBgColorId!= bgColorId) {
                    mDiffNoteValues.put(NoteColumns.BG_COLOR_ID, bgColorId);
                }
                mBgColorId = bgColorId;


                long createDate = note.has(NoteColumns.CREATED_DATE)? note
                       .getLong(NoteColumns.CREATED_DATE) : System.currentTimeMillis();
                if (mIsCreate || mCreatedDate!= createDate) {
                    mDiffNoteValues.put(NoteColumns.CREATED_DATE, createDate);
                }
                mCreatedDate = createDate;


                int hasAttachment = note.has(NoteColumns.HAS_ATTACHMENT)? note
                       .getInt(NoteColumns.HAS_ATTACHMENT) : 0;
                if (mIsCreate || mHasAttachment!= hasAttachment) {
                    mDiffNoteValues.put(NoteColumns.HAS_ATTACHMENT, hasAttachment);
                }
                mHasAttachment = hasAttachment;


                long modifiedDate = note.has(NoteColumns.MODIFIED_DATE)? note
                       .getLong(NoteColumns.MODIFIED_DATE) : System.currentTimeMillis();
                if (mIsCreate || mModifiedDate!= modifiedDate) {
                    mDiffNoteValues.put(NoteColumns.MODIFIED_DATE, modifiedDate);
                }
                mModifiedDate = modifiedDate;


                long parentId = note.has(NoteColumns.PARENT_ID)? note
                       .getLong(NoteColumns.PARENT_ID) : 0;
                if (mIsCreate || mParentId!= parentId) {
                    mDiffNoteValues.put(NoteColumns.PARENT_ID, parentId);
                }
                mParentId = parentId;


                String snippet = note.has(NoteColumns.SNIPPET)? note
                       .getString(NoteColumns.SNIPPET) : "";
                if (mIsCreate ||!mSnippet.equals(snippet)) {
                    mDiffNoteValues.put(NoteColumns.SNIPPET, snippet);
                }
                mSnippet = snippet;


                int type = note.has(NoteColumns.TYPE)? note.getInt(NoteColumns.TYPE)
                        : Notes.TYPE_NOTE;
                if (mIsCreate || mType!= type) {
                    mDiffNoteValues.put(NoteColumns.TYPE, type);
                }
                mType = type;


                int widgetId = note.has(NoteColumns.WIDGET_ID)? note.getInt(NoteColumns.WIDGET_ID)
                        : AppWidgetManager.INVALID_APPWIDGET_ID;
                if (mIsCreate || mWidgetId!= widgetId) {
                    mDiffNoteValues.put(NoteColumns.WIDGET_ID, widgetId);
                }
                mWidgetId = widgetId;


                int widgetType = note.has(NoteColumns.WIDGET_TYPE)? note
                       .getInt(NoteColumns.WIDGET_TYPE) : Notes.TYPE_WIDGET_INVALIDE;
                if (mIsCreate || mWidgetType!= widgetType) {
                    mDiffNoteValues.put(NoteColumns.WIDGET_TYPE, widgetType);
                }
                mWidgetType = widgetType;


                long originParent = note.has(NoteColumns.ORIGIN_PARENT_ID)? note
                       .getLong(NoteColumns.ORIGIN_PARENT_ID) : 0;
                if (mIsCreate || mOriginParent!= originParent) {
                    mDiffNoteValues.put(NoteColumns.ORIGIN_PARENT_ID, originParent);
                }
                mOriginParent = originParent;


                for (int i = 0; i < dataArray.length(); i++) {
                    JSONObject data = dataArray.getJSONObject(i);
                    SqlData sqlData = null;
                    if (data.has(DataColumns.ID)) {
                        long dataId = data.getLong(DataColumns.ID);
                        for (SqlData temp : mDataList) {
                            if (dataId == temp.getId()) {
                                sqlData = temp;
                            }
                        }
                    }


                    if (sqlData == null) {
                        sqlData = new SqlData(mContext);
                        mDataList.add(sqlData);
                    }


                    sqlData.setContent(data);
                }
            }
        } catch (JSONException e) {
            Log.e(TAG, e.toString());
            e.printStackTrace();
            return false;
        }
        return true;
    }


    // 获取笔记的 JSON 表示
    public JSONObject getContent() {
        try {
            JSONObject js = new JSONObject();


            if (mIsCreate) {
                Log.e(TAG, "it seems that we haven't created this in database yet");
                return null;
            }


            JSONObject note = new JSONObject();
            if (mType == Notes.TYPE_NOTE) {
                note.put(NoteColumns.ID, mId);
                note.put(NoteColumns.ALERTED_DATE, mAlertDate);
                note.put(NoteColumns.BG_COLOR_ID, mBgColorId);
                note.put(NoteColumns.CREATED_DATE, mCreatedDate);
                note.put(NoteColumns.HAS_ATTACHMENT, mHasAttachment);
                note.put(NoteColumns.MODIFIED_DATE, mModifiedDate);
                note.put(NoteColumns.PARENT_ID, mParentId);
                note.put(NoteColumns.SNIPPET, mSnippet);
                note.put(NoteColumns.TYPE, mType);
                note.put(NoteColumns.WIDGET_ID, mWidgetId);
                note.put(NoteColumns.WIDGET_TYPE, mWidgetType);
                note.put(NoteColumns.ORIGIN_PARENT_ID, mOriginParent);
                js.put(GTaskStringUtils.META_HEAD_NOTE, note);


                JSONArray dataArray = new JSONArray();
                for (SqlData sqlData : mDataList) {
                    JSONObject data = sqlData.getContent();
                    if (data!= null) {
                        dataArray.put(data);
                    }
                }
                js.put(GTaskStringUtils.META_HEAD_DATA, dataArray);
            } else if (mType == Notes.TYPE_FOLDER || mType == Notes.TYPE_SYSTEM) {
                note.put(NoteColumns.ID, mId);
                note.put(NoteColumns.TYPE, mType);
                note.put(NoteColumns.SNIPPET, mSnippet);
                js.put(GTaskStringUtils.META_HEAD_NOTE, note);
            }


            return js;
        } catch (JSONException e) {
            Log.e(TAG, e.toString());
            e.printStackTrace();
        }
        return null;
    }


    // 设置笔记的父 ID
    public void setParentId(long id) {
        mParentId = id;
        mDiffNoteValues.put(NoteColumns.PARENT_ID, id);
    }


    // 设置笔记的 GTASK ID
    public void setGtaskId(String gid) {
        mDiffNoteValues.put(NoteColumns.GTASK_ID, gid);
    }


    // 设置笔记的同步 ID
    public void setSyncId(long syncId) {
        mDiffNoteValues.put(NoteColumns.SYNC_ID, syncId);
    }


    // 重置本地修改标记
    public void resetLocalModified() {
        mDiffNoteValues.put(NoteColumns.LOCAL_MODIFIED, 0);
    }


    // 获取笔记的 ID
    public long getId() {
        return mId;
    }


    // 获取笔记的父 ID
    public long getParentId() {
        return mParentId;
    }


    // 获取笔记的摘要
    public String getSnippet() {
        return mSnippet;
    }


    // 判断是否为笔记类型
    public boolean isNoteType() {
        return mType == Notes.TYPE_NOTE;
    }


    // 提交笔记的更改，根据是否为创建操作进行插入或更新操作
    public void commit(boolean validateVersion) {
        if (mIsCreate) {
            if (mId == INVALID_ID && mDiffNoteValues.containsKey(NoteColumns.ID)) {
                mDiffNoteValues.remove(NoteColumns.ID);
            }


            Uri uri = mContentResolver.insert(Notes.CONTENT_NOTE_URI, mDiffNoteValues);
            try {
                mId = Long.valueOf(uri.getPathSegments().get(1));
            } catch (NumberFormatException e) {
                Log.e(TAG, "Get note id error :" + e.toString());
                throw new ActionFailureException("create note failed");
            }
            if (mId == 0) {
                throw new IllegalStateException("Create thread id failed");
            }


            if (mType == Notes.TYPE_NOTE) {
                for (SqlData sqlData : mDataList) {
                    sqlData.commit(mId, false, -1);
                }
            }
        } else {
            if (mId <= 0 && mId!= Notes.ID_ROOT_FOLDER && mId!= Notes.ID_CALL_RECORD_FOLDER) {
                Log.e(TAG, "No such note");
                throw new IllegalStateException("Try to update note with invalid id");
            }
            if (mDiffNoteValues.size() > 0) {
                mVersion++;
                int result = 0;
                if (!validateVersion) {
                    result = mContentResolver.update(Notes.CONTENT_NOTE_URI, mDiffNoteValues, "("
                            + NoteColumns.ID + "=?)", new String[] {
                        String.valueOf(mId)
                    });
                } else {
                    result = mContentResolver.update(Notes.CONTENT_NOTE_URI, mDiffNoteValues, "("
                            + NoteColumns.ID + "=?) AND (" + NoteColumns.VERSION + "<=?)",
                            new String[] {
                                    String.valueOf(mId), String.valueOf(mVersion)
                            });
                }
                if (result == 0) {
                    Log.w(TAG, "there is no update. maybe user updates note when syncing");
                }
            }


            if (mType == Notes.TYPE_NOTE) {
                for (SqlData sqlData : mDataList) {
                    sqlData.commit(mId, validateVersion, mVersion);
                }
            }
        }


        // 刷新本地信息
        loadFromCursor(mId);
        if (mType == Notes.TYPE_NOTE)
            loadDataContent();


        mDiffNoteValues.clear();
        mIsCreate = false;
    }
}